#pragma once

class YCMutex;

#define MAX_BUF_SIZE	2000 * 2000 * 3
#include "IReceiver.h"

/**
* CxgMpIuWFNgłB
*/
class EventReceiver : public IReceiver
{
public:

	/**
	* \z܂B
	*/
	EventReceiver(const wchar_t* memName, const wchar_t* writeEventName, const wchar_t* readEventName, HRESULT* phr);

	/**
	* j܂B
	*/
	virtual ~EventReceiver(void);

	/**
	* j܂B
	*/
	virtual void Destroy();

	/**
	* f[^M܂B
	*/
	virtual HRESULT Receive(BUFFER_DESC* pDesc, unsigned char** ppBuffer);

	/**
	* f[^̏ʒm܂B
	*/
	virtual HRESULT NotifyProcessed(unsigned char* pBuffer);

private:

	/**
	* oCxgێ܂B
	*/
	HANDLE m_hWriteEvent;

	/**
	* IuWFNgێ܂B
	*/
	YCMutex* m_pMutex;

	/**
	* Lt@C̃nhێ܂B
	*/
	HANDLE m_hSharedFile;

	/**
	* Lobt@ێ܂B
	*/
	SHARED_BUF* m_pSharedBuf;

	/**
	* [Jobt@̃TCYێ܂B
	*/
	size_t m_iLocalBufSize;

	/**
	* [Jobt@ێ܂B
	*/
	unsigned char* m_pLocalBuf;

};
